blog/urls.py
from django.urls import path
from . import views

# menggunakan app_name untuk mendefinisikan nama app nya agar saat ada nama file yang sama maka akan mencari sesuai dengan nama app nya
app_name = 'blog'

urlpatterns = [
    path('', views.all_blogs, name='all_blogs'),
    path('<int:blog_id>/', views.detail, name='detail'),
]

my_portofolio/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings
from portfolio import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home'),
    path('blog/', include('blog.urls')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
import blog
from django.db import models

# Create your models here.
class Blog(models.Model):
    title = models.CharField(max_length=255)
    desc = models.TextField()
    date = models.DateField()

    def __str__(self):
        return self.title

portfolio/models.py
from django.db import models

# Create your models here.
class Projects(models.Model):
    title = models.CharField(max_length=255)
    desc = models.CharField(max_length=255)
    photo = models.ImageField(upload_to='portfolio/images/')
    links = models.URLField(blank=True)

    def __str__(self):
        return self.title

blog/views.py
from django.shortcuts import render, get_object_or_404
from .models import Blog

# Create your views here.
def all_blogs(request):
    blogs = Blog.objects.order_by('-date')[:5] # mengam bil 5 data terakhir
    return render(request, 'blog/all_blogs.html', {'blogs':blogs})

def detail(request, blog_id):
    blog = get_object_or_404(Blog, pk=blog_id)
    return render(request, 'blog/detail.html', {'blog':blog})

portfolio/views.py
from django.shortcuts import render
from .models import Projects

# Create your views here.
def home(request):
    myprojects = Projects.objects.all()
    return render(request, 'portfolio/home.html', {'myprojects':myprojects})

blog/templates/blog/all_blogs.html
{% extends 'portfolio/base.html' %} {% block content %}
<h2>Dian's Blogs</h2>

<h4>Dian's has written {{ blogs.count }} blog{{ blogs.count|pluralize }}</h4>

{% for blog in blogs %}
<a href="{% url 'blog:detail' blog.id %}"><h2>{{ blog.title }}</h2></a>
<h5>{{ blog.date|date:'D, M d Y' }}</h5>
<p>{{ blog.desc|striptags|truncatechars:50 }}</p>
{% endfor %}

<a href="{% url 'home' %}">Home Page</a>

{% endblock %}

blog/templates/blog/detail.html
{% extends 'portfolio/base.html' %} {% block content %}

<h1>{{ blog.title }}</h1>

<h3>{{ blog.date|date:'D, F jS Y' }}</h3>

<p>{{ blog.desc|safe }}</p>

{% endblock %}

portfolio/templates/portfolio/base.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <!-- Bootstrap CSS -->
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css"
      integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l"
      crossorigin="anonymous"
    />
    <title>Dian's Portfolio</title>
  </head>
  <body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
      <a class="navbar-brand" href="#">Navbar</a>
      <button
        class="navbar-toggler"
        type="button"
        data-toggle="collapse"
        data-target="#navbarSupportedContent"
        aria-controls="navbarSupportedContent"
        aria-expanded="false"
        aria-label="Toggle navigation"
      >
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item active">
            <a class="nav-link" href="#"
              >Home <span class="sr-only">(current)</span></a
            >
          </li>
          <li class="nav-item">
            <a class="nav-link" href="#">About</a>
          </li>
          <li class="nav-item dropdown">
            <a
              class="nav-link dropdown-toggle"
              href="#"
              id="navbarDropdown"
              role="button"
              data-toggle="dropdown"
              aria-haspopup="true"
              aria-expanded="false"
            >
              Dropdown
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <a class="dropdown-item" href="#">Action</a>
              <a class="dropdown-item" href="#">Another action</a>
              <div class="dropdown-divider"></div>
              <a class="dropdown-item" href="#">Something else here</a>
            </div>
          </li>
          <li class="nav-item">
            <a
              class="nav-link disabled"
              href="#"
              tabindex="-1"
              aria-disabled="true"
              >Disabled</a
            >
          </li>
        </ul>
        <form class="form-inline my-2 my-lg-0">
          <input
            class="form-control mr-sm-2"
            type="search"
            placeholder="Search"
            aria-label="Search"
          />
          <button class="btn btn-outline-success my-2 my-sm-0" type="submit">
            Search
          </button>
        </form>
      </div>
    </nav>

    {% block content %} {% endblock %}

    <script
      src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
      integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-Piv4xVNRyMGpqkS2by6br4gNJ7DXjqk09RmUpJ8jgGtD7zP9yug3goQfGII0yAns"
      crossorigin="anonymous"
    ></script>
  </body>
</html>

portfolio/templates/portfolio/home.html
{% extends 'portfolio/base.html' %} {% block content %}

<h1>Dian's Portfolio</h1>

{% load static %}

<a href="{% static 'portfolio/resume.pdf' %}">Resume</a>

<img src="{% static 'portfolio/dian.png' %}" alt="My image" />

{% for projectPort in myprojects %}
<img src="{{ projectPort.photo.url }}" height="260" width="480" />
{% if projectPort.links %}
<br />
<a href="{{ projectPort.links }}">Links</a>
{% endif %} {% endfor %}

<a href="{% url 'blog:all_blogs' %}">Blog</a>

{% endblock %}